import java.util.Arrays;

public class MyArrayList<T> {
    private T[] currentArray;
    private int size = 0;

    public MyArrayList() {
        currentArray = (T[])new Object[10];
    }

    public MyArrayList(int inicialCapacity) {
        currentArray = (T[])new Object[inicialCapacity];
    }

    public int size() {
        return this.size;
    }

    private boolean needToExpand() {
        return currentArray.length - size <= 3;
    }

    private void expandArray() {
        currentArray = Arrays.copyOf(currentArray, currentArray.length*2);
    }

    public boolean add(T element) {
        if (needToExpand()) {
            expandArray();
        }
        currentArray[size] = element;
        size++;
        return true;
    }

    public T get(int index) throws IndexOutOfBoundsException {
        if (this.size <= index) {
            throw new IndexOutOfBoundsException();
        } else {
            return currentArray[index];
        }
    }

    public T remove(int index) {
        T returnElement = currentArray[index];
        System.arraycopy(currentArray, index+1, currentArray, index, size-index-1);
        size--;
        return  returnElement;
    }

    public T set(int index, T element) throws IndexOutOfBoundsException {
        T returnElement = currentArray[index];
        if (this.size <= index) {
            throw new IndexOutOfBoundsException();
        } else {
            currentArray[index] = element;
        }
        return returnElement;
    }

    public void clear() {
       for (int i=0; i<size; i++) {
           currentArray[i] = null;
       }
       size = 0;
    }

    public boolean isEmpty() {
        return size == 0;
    }

    public boolean contains(T element) {
        if (element == null) {
            for (int i=0; i<size; i++) {
                if (currentArray[i] == null) {
                    return true;
                }
            }
        }
        for (int i=0; i<size; i++) {
            if (currentArray[i].equals(element)) {
                return true;
            }
        }
        return false;
    }
}